package jalview.io.xdb.genbank;

import java.util.Enumeration;
import java.util.Hashtable;

public class GenBankFeature {
	public static final String MISC_TYPE = "misc_feature";
	public static final String SOURCE = "source";
	public static final String CDS = "CDS";
	public static final String GENE = "gene";
	public static final String EXON = "exon";
	public static final String INTRON = "intron";
	public static final String PRIM_TRANSCRIPT = "prim_transcript";
	public static final String mRNA = "mRNA";
	public static final String MOBILE_ELEMENT = "mobile_element";
	public static final String VARIATION = "variation";
	
	private String type;
	private Hashtable<String,String> qualifiers = new Hashtable<String,String>();
	private GenBankLocation location = null;
	
	public GenBankFeature() {
		super();
	}

	public GenBankFeature(String type) {
		super();
		this.type = type;
	}
	
	public void addQualifier(String key, String value){
		this.qualifiers.put(key, value);
	}
	public void updateQualifier(String key, String newValue){
		this.qualifiers.remove(key);
		this.qualifiers.put(key, newValue);
	}
	
	public String getQualifier(String key){
		return this.qualifiers.get(key);
	}

	public String getType() {
		return type;
	}

	public void setType(String type) {
		this.type = type;
	}
	public Enumeration<String> getQualifiersNames(){
		return this.qualifiers.keys();
	}
	public int getQualifiersSize(){
		return this.qualifiers.size();
	}

	public Hashtable<String, String> getFields() {
		return qualifiers;
	}

	public GenBankLocation getLocation() {
		return location;
	}

	public void setLocation(GenBankLocation location) {
		this.location = location;
	}
}
