package jalview.io.xdb.genbank;

/**
 *
 */
public class GenBankLocationPoint extends GenBankLocation {
    private String entry;
    private char prefix = 0;
    private int min = 0;
    private char symbol = 0;
    private int max = 0;
    private char sufix = 0;

    public GenBankLocationPoint() {
    }

    public GenBankLocationPoint(int point) {
        this.min = point;
        this.max = point;
    }

    public GenBankLocationPoint(int min, int max) {
        this.min = min;
        this.max = max;
    }

    public int getMinor() {
        return this.min;
    }

    public int getMajor() {
        return this.max;
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        if( prefix != 0 && prefix != ' ' ) {
            sb.append(prefix);
        }
        if( symbol == '.' || symbol == '^' ) {
            sb.append( String.format("%d%c%d",min,symbol,max) );
        } else {
            if( min != max ) {
               sb.append( String.format("%d.%d",min,max) );
            } else {
               sb.append( min );
            }
        }
        if( sufix != 0 && sufix != ' ' ) {
            sb.append(sufix);
        }
        return sb.toString();
    }

    /**
     * @return the prefix
     */
    public char getPrefix() {
        return prefix;
    }

    /**
     * @param prefix the prefix to set
     */
    public void setPrefix(char prefix) {
        this.prefix = prefix;
    }

    /**
     * @return the min
     */
    public int getMin() {
        return min;
    }

    /**
     * @param min the min to set
     */
    public void setMin(int min) {
        this.min = min;
    }

    /**
     * @return the symbol
     */
    public char getSymbol() {
        return symbol;
    }

    /**
     * @param symbol the symbol to set
     */
    public void setSymbol(char symbol) {
        this.symbol = symbol;
    }

    /**
     * @return the max
     */
    public int getMax() {
        return max;
    }

    /**
     * @param max the max to set
     */
    public void setMax(int max) {
        this.max = max;
    }

    /**
     * @return the sufix
     */
    public char getSufix() {
        return sufix;
    }

    /**
     * @param sufix the sufix to set
     */
    public void setSufix(char sufix) {
        this.sufix = sufix;
    }

    /**
     * @return the entry
     */
    public String getEntry() {
        return entry;
    }

    /**
     * @param entry the entry to set
     */
    public void setEntry(String entry) {
        this.entry = entry;
    }

}
