package jalview.io.xdb.genbank;

/**
 *
 */
public class GenBankLocationRange extends GenBankLocation {
    private String entry = null;
    private GenBankLocationPoint start = null;
    private GenBankLocationPoint end = null;

    public GenBankLocationRange() {
    }

    @Override
    public int getMinor() {
        return start == null ? 0 : start.getMinor();
    }

    @Override
    public int getMajor() {
        return end == null ? 0 : end.getMajor();
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
//        if( getDirecao() != '5' ) {
//            sb.append("complement(");
//        }
        if( entry != null ) {
            sb.append(entry);
            sb.append(":");
        }
        if( getStart() != null ) {
            sb.append( getStart().toString() );
        }
        if( getEnd() != null && getStart() != getEnd() && !start.equals(end) ) {
            sb.append("..");
            sb.append( getEnd().toString() );
        }
        return sb.toString();
    }

    /**
     * @return the entry
     */
    public String getEntry() {
        return entry;
    }

    /**
     * @param entry the entry to set
     */
    public void setEntry(String entry) {
        this.entry = entry;
    }

    /**
     * @return the start
     */
    public GenBankLocationPoint getStart() {
        return start;
    }

    /**
     * @param start the start to set
     */
    public void setStart(GenBankLocationPoint start) {
        this.start = start;
    }

    /**
     * @return the end
     */
    public GenBankLocationPoint getEnd() {
        return end;
    }

    /**
     * @param end the end to set
     */
    public void setEnd(GenBankLocationPoint end) {
        this.end = end;
    }

}
