package jalview.io.xdb.genbank;

import java.util.Vector;
/**
 * A line like the following:
 *   1 aatgaaggtt catttttcat tctcacaaac taatgaaacc ctgcttatct taaaccaacc
 * will be mapped as:
 * 	id: 1
 *  sequences: {"aatgaaggtt", "catttttcat", "tctcacaaac", "taatgaaacc", "ctgcttatct", "taaaccaacc"}
 *  Each sequence has 8 nucleotides long
 * @author darolmar
 *
 */
public class GenBankSequence {
	//Initial position
	private int id;
	//Sequences in that line
	private Vector<String> sequences;

	public GenBankSequence() {
		super();
		sequences = new Vector<String>();
	}

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public Vector<String> getSequences() {
		return sequences;
	}

	public void setSequences(Vector<String> sequences) {
		this.sequences = sequences;
	}
	
	public String getSequencesAsString(){
		StringBuffer sb = new StringBuffer();
		for (String seq:sequences)			
			sb.append(seq).append(" ");				
		return sb.toString();		
	}
	
	public String toString(){
		StringBuffer sb = new StringBuffer()
			.append("        ").append(this.id);
		for (String seq:sequences)			
			sb.append(" ").append(seq);
		sb.append("\n");				
		return sb.toString();
	}
	
}
